Date: Sun, 11 Mar 2001 12:02:12 +0200
From: "Vladislav V. Zhuk" <admin@dru.skif.net>

Перепробовал я с десяток текстмордовых редакторов под *NIX, но удобнее
le ничего не нашел. Первым делом я настроил цвета, чтоб радовали глаз.
А вторым - назначение клавиш для более комфортной работы.
(хотя сам стиль группировки комбинаций клавиш сделан достаточно
понятно и легко запоминается - некоторые из них мне хотелось бы
переназначить). И как оказалось сделать это достаточно просто.

Вначале необходимо получить файл текущих комбинаций:
le --dump-keymap > ~/.le/keymap , а затем отредактировать его по вкусу.
комментарии в этом файле не предусмотрены, но учитывая, что ошибочные
строки просто игнорируются для комментария можно использовать
классический символ "#".
Названия ключевых слов достаточно ясно описывают выполняемую данной
комбинацией функцию. Для выполнения одной и той же функции можно наз-
начить несколько комбинаций клавиш указав несколько раз ключевое
слово.
Теперь об обозначении комбинаций клавиш:
для начала (по старой русской традиции) желательно ознакомиться с
информацией о терминале (man terminfo, vi /etc/termcap) - это
позволит не только получить описание различных клавиш, но и поможет
разобраться в ситуациях когда что-то не получается.
Для назначения действию клавиши достаточно добавить символ "$" к
ее Cap-name'у:

Пример описания клавиш в terminfo:
       Variable        Cap-     TCap    Description
       Numeric         name     Code
       key_f6          kf6      k6      F6 function key
       key_f7          kf7      k7      F7 function key
       key_f8          kf8      k8      F8 function key
       key_f9          kf9      k9      F9 function key
       key_home        khome    kh      home key

И вот как это выглядит в keymap:
beginning-of-line       $khome
copy-block              $kf5
move-block              $kf6
search-forward          $kf7

Комбинации с клавишей Ctrl выглядят как обычно, с добавлением символа
"^". Нижеуказанные комбинации означают одновременное нажатие клавиши
Ctrl и соотв. буквы:
delete-line             ^Y
undelete                ^U
new-line                ^J

Последовательное нажатие клавиш обозначается символом "|":
switch-autoindent-mode  ^A|A
switch-russian-mode     ^A|R
данные сокращения обозначают одновременное нажатие Ctrl и A,
и после того как отпустили - клавиша R.

!!! Замечание: в данном случае регистр последней клавиши имеет
значение, т.е. чтобы однозначно идентифицировать команду с комбинацией
вне зависимости от регистра нужно указать данную последовательность
следующим образом:
switch-russian-mode     ^A|R
switch-russian-mode     ^A|r

Клавиша Esc обозначается "\e" (без кавычек). Пример использования:
beginning-of-file       \e|$khome
end-of-file             \e|$kend

Нижеуказанные комбинации означают, что команда будет выполнена
как при одновременном нажатии указанных клавиш, так и с паузой
приблизительно в одну секунду между последовательным нажатием
этих клавиш:
start-drag-mark         ${kf4}V
mark-all                ${kf4}A

Для обозначения комбинаций можно использовать модификаторы:
$1 - shift, $2 - control, $3 - shift+control или alt, которые
добавляются перед кодом клавиш:
switch-file             $1kf3
start-replace           $2kf7
compile                 $3kf9

Ну, и в добавок ко всему этому многообразию можно непосредственно
указывать Esc-последовательности (например, когда вы не можете найти
Cap-name нужной клавиши). Esc-код можно узнать если запустить cat
и нажать соотв. клавишу (в некоторых случаях перед этим нужно сделать
`tput smkx').
Например, cat выдает такой код ^[[I (как известно, ^[ - это код
символа Esc), то в keymap нужно записать (с учетом замены ^[ на \e)
следующее: \e[I   Например:
mark-beginning-of-file  \eO6H
mark-end-of-file        \eO6F
mark-next-page          \e[6;2~
mark-previous-page      \e[5;2~

-----------------------------------------------------------------
Замечание:
- не всегда удается назначить нужной комбинации нужную функцию -
  иногда это определено в termcap, а иногда некоторые комбинации
  выдают один и тот же код, как например PageUp и Ctrl-PageUp.

Желаю творческих успехов!!!

Благодарности:
- автору программы Александру Лукьянову ("Alexander V. Lukyanov"
  <lav@yars.free.net>) за столь дивную программу и помощь в ее
  настройке.
- разработчикам FreeBSD за замечательную операционную систему :))
